/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2014                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


/**
 * \file CubeFileTmpLayout.h
 * \brief It provides names for the files in the CUBE report, which will operate only with temporary files. (they are detected by ".data" or ".index" name)
 */
#ifndef __FILE_TMP_LAYOUT_H
#define __FILE_TMP_LAYOUT_H


#include <inttypes.h>
#include <stdint.h>
#include <map>
#include <string>
#include <vector>
#include <iostream>

// #include "CubeMetric.h"

#include "CubeFileBaseLayout.h"
#include "CubeServices.h"

namespace cube
{
class Metric;

class FileTmpLayout : public FileBaseLayout
{
protected:

    virtual std::string
    getPathToAnchor();
    virtual std::string
    getPathToData();
    virtual std::string
    getPathToMetricData( cube::Metric* );
    virtual std::string
    getPathToMetricIndex( cube::Metric* );

    virtual std::string
    getAnchorName();
    virtual std::string
    getMetricDataName( cube::Metric* );
    virtual std::string
    getMetricIndexName( cube::Metric* );


public:
    FileTmpLayout() : FileBaseLayout( "" )
    {
    };
//                      FileTmpLayout():FileBaseLayout(services::create_random_string(20)) {};
};
};

#endif
